#include <stdlib.mqh>

extern string PRICE_SELECT = "BUY/SELL ONLY @ SET PRICE";
extern double BuyOrderPrice = 0.0;
extern double SellOrderPrice = 0.0;
extern string TRADE_DIRECTION = "SELECT TRADES LONG OR SHORT";
extern bool TradeShort = TRUE;
extern bool TradeLong = TRUE;
extern bool UseDPO = TRUE;
extern bool UseCCI = TRUE;
extern int CCIPeriod = 15;
extern double LotSize = 0.01;
extern double LotIncrement = 0.01;
extern double Multiplier = 0.0;
extern int ProfitTarget = 1;
extern double SL = 25.0;
extern int OpenOnTick = 1;
extern int Spacing = 15;
extern int TrendSpacing = 1000;
extern double CounterTrendMultiplier = 1.0;
extern int CloseDelay = 91;
extern bool CeaseTrading = FALSE;
extern string PasueTrading = "Pause Trading at Timeinterval";
extern int StartTime = 0;
extern int EndTime = 0;
extern string QuitTrading = "Quit Trading at Time";
extern int endDayHourMinute = 0;
extern bool RightSideLabel = TRUE;
extern int SessionTarget = 10000;
extern int MaximumBuyOrders = 10;
extern int MaximumSellOrders = 10;
extern double SLTotalinDollar = 5000.0;
extern bool AlertOn = TRUE;
extern bool SoundON = TRUE;
int gi_unused_252 = 1;
double g_price_256 = 0.0;
int g_error_264 = 0/* NO_ERROR */;
int g_pos_268 = 0;
int g_slippage_272 = 0;
int g_magic_276 = 0;
string g_str_concat_280;
double g_close_288 = 0.0;
int gi_296 = 0;
int gi_300 = 0;
bool gi_304 = FALSE;
string g_str_concat_308;
double gd_unused_316;
double gi_324;
int gi_unused_328 = 100;
double gd_332 = 10000000.0;
double gd_340 = 10000000.0;

int init() {
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") g_magic_276 = 801001;
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") g_magic_276 = 801002;
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") g_magic_276 = 801003;
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") g_magic_276 = 801004;
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") g_magic_276 = 801005;
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") g_magic_276 = 801006;
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") g_magic_276 = 801007;
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") g_magic_276 = 801008;
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") g_magic_276 = 801009;
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") g_magic_276 = 801010;
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") g_magic_276 = 801011;
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") g_magic_276 = 801012;
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") g_magic_276 = 801013;
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") g_magic_276 = 801014;
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") g_magic_276 = 801015;
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") g_magic_276 = 801016;
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") g_magic_276 = 801017;
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") g_magic_276 = 801018;
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") g_magic_276 = 801019;
   if (g_magic_276 == 0) g_magic_276 = 801999;
   gd_unused_316 = AccountBalance();
   g_str_concat_280 = StringConcatenate(Symbol(), " ", Period(), " ", "PM", " S_ID: ", TimeLocal());
   g_str_concat_308 = StringConcatenate("", Symbol(), "_", Period(), "_M", ".txt");
   CalculateLotPrecision();
   return (0);
}

int deinit() {
   if (ObjectFind("MidPoint") == 0) ObjectDelete("MidPoint");
   if (ObjectFind("MarginPercent") == 0) ObjectDelete("MarginPercent");
   if (ObjectFind("LowMarginPercent") == 0) ObjectDelete("LowMarginPercent");
   Comment("");
   return (0);
}

void CalculateLotPrecision() {
   double l_lotstep_0 = MarketInfo(Symbol(), MODE_LOTSTEP);
   if (l_lotstep_0 == 1.0) gi_324 = 0;
   if (l_lotstep_0 == 0.1) gi_324 = 1;
   if (l_lotstep_0 == 0.01) gi_324 = 2;
   if (l_lotstep_0 == 0.001) gi_324 = 3;
}
//----------------------------------------------------------
void PlaceBuyOrder() {
   double ld_0;
   double l_lots_8;
   double l_ord_open_price_16;
   double l_ord_open_price_24 = 1000;
   g_close_288 = 0;
   RefreshRates();
   for (g_pos_268 = OrdersTotal() - 1; g_pos_268 >= 0; g_pos_268--) {
      if (OrderSelect(g_pos_268, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276 && OrderType() == OP_BUY) {
            if (OrderOpenPrice() < l_ord_open_price_16) l_ord_open_price_16 = OrderOpenPrice();
            if (OrderOpenPrice() > l_ord_open_price_24) l_ord_open_price_24 = OrderOpenPrice();
            ld_0++;
         }
      }
   }
 
 
 if (Ask >= l_ord_open_price_24 + TrendSpacing * Point) {
      if (Multiplier == 1.0) l_lots_8 = NormalizeDouble(MathPow(2, ld_0) * LotSize, gi_324);
   else l_lots_8 = NormalizeDouble(LotSize + LotIncrement * ld_0, gi_324);
 }
  if (Ask <= l_ord_open_price_16 - Spacing * Point) {
    if (CounterTrendMultiplier == 1.0) l_lots_8 = NormalizeDouble(MathPow(2, ld_0) * LotSize, gi_324);
    else l_lots_8 = NormalizeDouble(LotSize + LotIncrement * ld_0, gi_324);
   }

   if (ld_0 == 0.0) l_lots_8 = NormalizeDouble(LotSize, gi_324);
   if (l_lots_8 == 0.0) {
      if (Multiplier == 1.0) l_lots_8 = NormalizeDouble(LotSize, gi_324);
      else l_lots_8 = NormalizeDouble(LotSize, gi_324);
   }
   if (IsTradeAllowed() == TRUE && Ask < BuyOrderPrice && ld_0 < MaximumBuyOrders) {
      if (SL == 0.0) g_price_256 = 0;
      else g_price_256 = Ask - SL * Point;
      OrderSend(Symbol(), OP_BUY, l_lots_8, Ask, g_slippage_272, g_price_256, 0, g_str_concat_280, g_magic_276, 32768);
   }
   
   
   g_error_264 = GetLastError();
   if (g_error_264 != 0/* NO_ERROR */) {
      Write("Error opening BUY order: " + ErrorDescription(g_error_264) + " (C" + g_error_264 + ")  Ask:" + Ask + "  Slippage:" + g_slippage_272);
      return;
   }
   g_close_288 = Close[0];
}
//+---------------------------------------------
void PlaceSellOrder() {
   double ld_0;
   double l_lots_8;
   double l_ord_open_price_16;
   double l_ord_open_price_24 = 1000;
   g_close_288 = 0;
   RefreshRates();
   for (g_pos_268 = OrdersTotal() - 1; g_pos_268 >= 0; g_pos_268--) {
      if (OrderSelect(g_pos_268, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276 && OrderType() == OP_SELL) {
            if (OrderOpenPrice() > l_ord_open_price_16) l_ord_open_price_16 = OrderOpenPrice();
            if (OrderOpenPrice() < l_ord_open_price_24) l_ord_open_price_24 = OrderOpenPrice();
            ld_0++;
         }
      }
   }
   if (Bid <= l_ord_open_price_24 - TrendSpacing * Point) {
     if (Multiplier == 1.0) l_lots_8 = NormalizeDouble(MathPow(2, ld_0) * LotSize, gi_324);
     else l_lots_8 = NormalizeDouble(LotSize + LotIncrement * ld_0, gi_324);
  }
   if (Bid >= l_ord_open_price_16 + Spacing * Point) {
     if (CounterTrendMultiplier == 1.0) l_lots_8 = NormalizeDouble(MathPow(2, ld_0) * LotSize, gi_324);
   else l_lots_8 = NormalizeDouble(LotSize + LotIncrement * ld_0, gi_324);
  }
  
   if (ld_0 == 0.0) l_lots_8 = NormalizeDouble(LotSize, gi_324);
   if (l_lots_8 == 0.0) {
      if (Multiplier == 1.0) l_lots_8 = NormalizeDouble(LotSize, gi_324);
      else l_lots_8 = NormalizeDouble(LotSize, gi_324);
   }
   if (IsTradeAllowed() == TRUE && Bid > SellOrderPrice && ld_0 < MaximumSellOrders) {
      if (SL == 0.0) g_price_256 = 0;
      else g_price_256 = Bid + SL * Point;
      OrderSend(Symbol(), OP_SELL, l_lots_8, Bid, g_slippage_272, g_price_256, 0, g_str_concat_280, g_magic_276, 255);
   }
   g_error_264 = GetLastError();
   if (g_error_264 != 0/* NO_ERROR */) {
      Write("Error opening SELL order: " + ErrorDescription(g_error_264) + " (D" + g_error_264 + ")  Bid:" + Bid + "  Slippage:" + g_slippage_272);
      return;
   }
   g_close_288 = Close[0];
}

int start() {
   double ld_0;
   int li_24;
   int li_28;
   double ld_48;
   double ld_56;
   double l_ord_open_price_96;
   double l_ord_open_price_112;
   int l_ticket_160;
   int l_ticket_164;
   int l_ticket_168;
   int l_ticket_172;
   double ld_176;
   double ld_184;
   double ld_192;
   double ld_200;
   string l_dbl2str_232;
   string l_dbl2str_240;
   string l_dbl2str_248;
   double l_ord_open_price_64 = 999;
   double l_ord_open_price_72 = 0.0001;
   double l_ord_open_price_80 = 999;
   double l_ord_open_price_88 = 0.0001;
   double ld_120 = 0;
   double ld_128 = 0;
   double ld_136 = 0;
   double ld_144 = 0;
   double ld_152 = 0;
   bool li_208 = FALSE;
   bool li_212 = FALSE;
   double ld_unused_216 = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   CutTotalLoss();
   for (g_pos_268 = OrdersTotal() - 1; g_pos_268 >= 0; g_pos_268--) {
      if (OrderSelect(g_pos_268, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276) {
            ld_120 = OrderProfit() + OrderSwap() + OrderCommission();
            if (OrderType() == OP_BUY) {
               if (OrderOpenPrice() >= l_ord_open_price_72) {
                  l_ord_open_price_72 = OrderOpenPrice();
                  l_ticket_160 = OrderTicket();
                  ld_176 = ld_120;
               }
               if (OrderOpenPrice() <= l_ord_open_price_64) {
                  l_ord_open_price_64 = OrderOpenPrice();
                  l_ticket_164 = OrderTicket();
                  ld_184 = ld_120;
               }
               li_28++;
               if (li_28 > gi_296) gi_296 = li_28;
               ld_48 += OrderLots();
               ld_128 += ld_120;
               if (ld_120 > 0.0) ld_144 += ld_120;
            }
            if (OrderType() == OP_SELL) {
               if (OrderOpenPrice() <= l_ord_open_price_80) {
                  l_ord_open_price_80 = OrderOpenPrice();
                  l_ticket_172 = OrderTicket();
                  ld_200 = ld_120;
               }
               if (OrderOpenPrice() >= l_ord_open_price_88) {
                  l_ord_open_price_88 = OrderOpenPrice();
                  l_ticket_168 = OrderTicket();
                  ld_192 = ld_120;
               }
               li_24++;
               if (li_24 > gi_300) gi_300 = li_24;
               ld_56 += OrderLots();
               ld_136 += ld_120;
               if (ld_120 > 0.0) ld_152 += ld_120;
            }
         }
      }
   }
   double ld_8 = ProfitTarget;
   double ld_16 = ProfitTarget;
   if (l_ord_open_price_72 >= l_ord_open_price_88) l_ord_open_price_96 = l_ord_open_price_72;
   else l_ord_open_price_96 = l_ord_open_price_88;
   if (l_ord_open_price_64 <= l_ord_open_price_80) l_ord_open_price_112 = l_ord_open_price_64;
   else l_ord_open_price_112 = l_ord_open_price_80;
   double l_price_104 = (l_ord_open_price_96 + l_ord_open_price_112) / 2.0;
   RefreshRates();
   if (ld_128 + ld_136 >= ProfitTarget) {
      for (g_pos_268 = OrdersTotal() - 1; g_pos_268 >= 0; g_pos_268--) {
         if (OrderSelect(g_pos_268, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), g_slippage_272, Green);
            g_error_264 = GetLastError();
            if (g_error_264 != 0/* NO_ERROR */) Write("Error closing order " + OrderTicket() + ": " + ErrorDescription(g_error_264) + " (F" + g_error_264 + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));
         }
      }
   }
   RefreshRates();
   if (l_ord_open_price_72 > 0.0 && l_ord_open_price_64 < 1000.0) {
      if (Ask <= l_ord_open_price_64 - Spacing * Point || Ask >= l_ord_open_price_72 + TrendSpacing * Point) {
         li_212 = TRUE;
         if (OpenOnTick == 1 && g_close_288 > 0.0 && Close[0] < g_close_288) li_212 = TRUE;
      }
      if (CeaseTrading && li_28 == 0) li_212 = FALSE;
      if (CCIDecision(1) != 1 || Direction(1) != 1 || PauseAtTime(StartTime, EndTime, 1) != 1) li_212 = FALSE;
      if (li_212 && TradeLong == TRUE) PlaceBuyOrder();
   }
   if (l_ord_open_price_88 > 0.0 && l_ord_open_price_80 < 1000.0) {
      if (Bid >= l_ord_open_price_88 + Spacing * Point || Bid <= l_ord_open_price_80 - TrendSpacing * Point) {
         li_208 = TRUE;
         if (OpenOnTick == 1 && g_close_288 > 0.0 && Close[0] > g_close_288) li_208 = TRUE;
      }
      if (CeaseTrading && li_24 == 0) li_208 = FALSE;
      if (CCIDecision(-1) != -1 || Direction(-1) != -1 || PauseAtTime(StartTime, EndTime, -1) != -1) li_208 = FALSE;
      if (li_208 && TradeShort == TRUE) PlaceSellOrder();
   }
   if (AccountMargin() != 0.0) ld_0 = MathRound(100.0 * (AccountEquity() / AccountMargin()));
   if (gd_332 > ld_0) gd_332 = ld_0;
   if (AccountEquity() < gd_340) gd_340 = AccountEquity();
   string ls_224 = "                  PipMakerV10" 
      + "\n" 
      + "                            BuyOrderPrice       " + DoubleToStr(BuyOrderPrice, Digits) 
      + "\n" 
      + "                            SellOrderPrice        " + DoubleToStr(SellOrderPrice, Digits) 
      + "\n" 
      + "                            ProfitTarget           " + DoubleToStr(ld_8, 2) 
      + "\n" 
      + "                            SessionTarget       " + DoubleToStr(SessionTarget, 2) 
      + "\n" 
      + "                            Buys                    " + li_28 + "  Highest: " + gi_296 
      + "\n" 
      + "                            BuyLots                " + DoubleToStr(ld_48, 2) 
      + "\n" 
      + "                            BuyProfit              " + DoubleToStr(ld_128, 2) 
      + "\n" 
      + "                            Highest Buy           " + DoubleToStr(l_ord_open_price_72, Digits) + " #" + DoubleToStr(l_ticket_160, 0) + "  Profit: " + DoubleToStr(ld_176, 2) 
      + "\n" 
      + "                            Highest Sell           " + DoubleToStr(l_ord_open_price_88, Digits) + " #" + DoubleToStr(l_ticket_168, 0) + "  Profit: " + DoubleToStr(ld_192, 2) 
      + "\n" 
      + "\n" 
      + "                            ProfitTarget           " + DoubleToStr(ld_16, 2) 
      + "\n" 
      + "                            Sells                     " + li_24 + "  Highest: " + gi_300 
      + "\n" 
      + "                            SellLots                 " + DoubleToStr(ld_56, 2) 
      + "\n" 
      + "                            SellProfit               " + DoubleToStr(ld_136, 2) 
      + "\n" 
      + "                            Lowest Buy            " + DoubleToStr(l_ord_open_price_64, Digits) + " #" + DoubleToStr(l_ticket_164, 0) + "  Profit: " + DoubleToStr(ld_184, 2) 
      + "\n" 
      + "                            Lowest Sell            " + DoubleToStr(l_ord_open_price_80, Digits) + " #" + DoubleToStr(l_ticket_172, 0) + "  Profit: " + DoubleToStr(ld_200, 2) 
      + "\n" 
      + "\n" 
      + "                            Balance                " + DoubleToStr(AccountBalance(), 2) 
      + "\n" 
      + "                            Equity                  " + DoubleToStr(AccountEquity(), 2) + "  Lowest: " + DoubleToStr(gd_340, 2) 
      + "\n" 
      + "\n" 
      + "                            Margin                  " + DoubleToStr(AccountMargin(), 2) 
      + "\n" 
      + "                            MarginPercent        " + DoubleToStr(ld_0, 2) 
      + "\n" 
      + "                            LowMarginPercent  " + DoubleToStr(gd_332, 2) 
      + "\n" 
   + "                            Current Time is      " + TimeToStr(TimeCurrent(), TIME_SECONDS);
   Comment(ls_224);
   if (RightSideLabel) {
      l_dbl2str_232 = DoubleToStr(ld_0, 0);
      l_dbl2str_240 = DoubleToStr(gd_332, 0);
      l_dbl2str_248 = DoubleToStr(AccountBalance(), 0);
      ObjectDelete("MarginPercent");
      if (ObjectFind("MarginPercent") != 0) {
         ObjectCreate("MarginPercent", OBJ_TEXT, 0, Time[0], Close[0]);
         ObjectSetText("MarginPercent", l_dbl2str_232 + "%  " + l_dbl2str_240 + "%  $" + l_dbl2str_248, 10, "Arial Black", DodgerBlue);
      } else ObjectMove("MarginPercent", 0, Time[0], Close[0]);
   }
   if (ObjectFind("MidPoint") != 0) {
      ObjectCreate("MidPoint", OBJ_HLINE, 0, Time[0], l_price_104);
      ObjectSet("MidPoint", OBJPROP_COLOR, Gold);
      ObjectSet("MidPoint", OBJPROP_WIDTH, 2);
   } else ObjectMove("MidPoint", 0, Time[0], l_price_104);
   getSessionTarget();
   QuitAtTime(endDayHourMinute);
   return (0);
}

void Write(string as_0) {
   int l_file_8;
   if (gi_304) {
      l_file_8 = FileOpen(g_str_concat_308, FILE_CSV|FILE_WRITE|FILE_READ, "/t");
      if (l_file_8 < 1) {
         Print("Error opening audit file: Code ", GetLastError());
         return;
      }
      if (!FileSeek(l_file_8, 0, SEEK_END)) {
         Print("Error seeking end of audit file: Code ", GetLastError());
         return;
      }
      if (FileWrite(l_file_8, TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS) + "  " + as_0) < 1) {
         Print("Error writing to audit file: Code ", GetLastError());
         return;
      }
      FileClose(l_file_8);
   }
}

int Direction(int ai_0) {
   int li_ret_4;
   if (UseDPO == TRUE) {
      if (iMA(Symbol(), PERIOD_M30, 2, 0, MODE_LWMA, PRICE_WEIGHTED, 0) > iOpen(Symbol(), PERIOD_D1, 0) + MarketInfo(Symbol(), MODE_SPREAD) * Point) li_ret_4 = 1;
      if (iMA(Symbol(), PERIOD_M30, 2, 0, MODE_LWMA, PRICE_WEIGHTED, 0) < iOpen(Symbol(), PERIOD_D1, 0) - MarketInfo(Symbol(), MODE_SPREAD) * Point) li_ret_4 = -1;
   } else {
      if (ai_0 == 1) li_ret_4 = 1;
      if (ai_0 == -1) li_ret_4 = -1;
   }
   return (li_ret_4);
}

int CCIDecision(int ai_0) {
   int li_ret_4;
   double l_icci_8;
   double l_icci_16;
   if (UseCCI == TRUE) {
      l_icci_8 = iCCI(NULL, CCIPeriod, 14, PRICE_CLOSE, 1);
      l_icci_16 = iCCI(NULL, PERIOD_M1, 14, PRICE_CLOSE, 1);
      if (l_icci_8 > 0.0 && l_icci_16 > 0.0) li_ret_4 = 1;
      if (l_icci_8 < 0.0 && l_icci_16 < 0.0) li_ret_4 = -1;
   } else {
      if (ai_0 == 1) li_ret_4 = 1;
      if (ai_0 == -1) li_ret_4 = -1;
   }
   return (li_ret_4);
}

void QuitAtTime(int ai_0) {
   int li_4 = 10000 * TimeDay(TimeCurrent()) + 100 * TimeHour(TimeCurrent()) + TimeMinute(TimeCurrent());
   if (li_4 >= ai_0 && ai_0 != 0) {
      CeaseTrading = TRUE;
      ExitAllTrades(Gold, "Stopped Trading because endtime reached!");
   }
}

int PauseAtTime(int ai_0, int ai_4, int ai_8) {
   int li_ret_12;
   int li_16;
   if (ai_0 != 0 && ai_4 != 0) {
      li_16 = 10000 * TimeDay(TimeCurrent()) + 100 * TimeHour(TimeCurrent()) + TimeMinute(TimeCurrent());
      if (li_16 >= ai_0 && li_16 <= ai_4) li_ret_12 = 0;
      else {
         if (ai_8 == 1) li_ret_12 = 1;
         if (ai_8 == -1) li_ret_12 = -1;
      }
   } else {
      if (ai_8 == 1) li_ret_12 = 1;
      if (ai_8 == -1) li_ret_12 = -1;
   }
   return (li_ret_12);
}

double SessionProfit() {
   double ld_0;
   double ld_8;
   for (int l_pos_24 = OrdersHistoryTotal() - 1; l_pos_24 >= 0; l_pos_24--) {
      OrderSelect(l_pos_24, SELECT_BY_POS, MODE_HISTORY);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276)
         if (OrderComment() == g_str_concat_280) ld_0 += OrderProfit();
   }
   for (int l_pos_28 = OrdersTotal() - 1; l_pos_28 >= 0; l_pos_28--) {
      OrderSelect(l_pos_28, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276)
         if (OrderComment() == g_str_concat_280) ld_8 += OrderProfit();
   }
   double ld_ret_16 = ld_0 + ld_8;
   return (ld_ret_16);
}

void getSessionTarget() {
   if (SessionTarget > 0) {
      if (SessionProfit() >= SessionTarget) {
         CeaseTrading = TRUE;
         ExitAllTrades(Aqua, "EA STOPPED! TARGET ACHEIVED. HALLELUJAH AMEN***!");
         if (AlertOn == TRUE) Alert("EA STOPPED! TARGET ACHEIVED. HALLELUJAH AMEN***", Symbol());
         if (SoundON == TRUE) PlaySound("alert2.wav");
      }
   }
}

void ExitAllTrades(color a_color_0, string as_4) {
   int l_ord_close_12;
   for (int l_pos_16 = OrdersTotal() - 1; l_pos_16 >= 0; l_pos_16--) {
      OrderSelect(l_pos_16, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276) {
         l_ord_close_12 = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), g_slippage_272, a_color_0);
         if (l_ord_close_12 == 1) Print("Closed all positions because ", as_4);
      }
   }
}

void CutTotalLoss() {
   double ld_0;
   double ld_8;
   for (g_pos_268 = OrdersTotal() - 1; g_pos_268 >= 0; g_pos_268--) {
      if (OrderSelect(g_pos_268, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276 && OrderType() == OP_BUY && OrderProfit() < 0.0) ld_8 += OrderProfit() + OrderSwap() + OrderCommission();
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == g_magic_276 && OrderType() == OP_SELL && OrderProfit() < 0.0) ld_0 += OrderProfit() + OrderSwap() + OrderCommission();
      }
   }
   double ld_16 = MathAbs(ld_8 + ld_0);
   if (ld_8 < 0.0 || ld_0 < 0.0 && ld_16 >= SLTotalinDollar) {
      if (TimeCurrent() - OrderOpenTime() >= CloseDelay) {
         ExitAllTrades(Aqua, "SLTotalinDollar was reached");
         if (AlertOn == TRUE) Alert("TOTAL LOSS REACHED, EA STOPPED..", Symbol());
         if (SoundON == TRUE) PlaySound("wait.wav");
         g_error_264 = GetLastError();
         if (g_error_264 != 0/* NO_ERROR */) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(g_error_264) + " (A" + g_error_264 + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));
         CeaseTrading = TRUE;
      }
   }
}